/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the Validation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Validation{}

// Validation struct for Validation
type Validation struct {
	Enabled *bool `json:"enabled,omitempty"`
	Rules []ValidationRule `json:"rules,omitempty"`
	ErrorMessage *Message `json:"error_message,omitempty"`
}

// NewValidation instantiates a new Validation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewValidation() *Validation {
	this := Validation{}
	return &this
}

// NewValidationWithDefaults instantiates a new Validation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewValidationWithDefaults() *Validation {
	this := Validation{}
	return &this
}

// GetEnabled returns the Enabled field value if set, zero value otherwise.
func (o *Validation) GetEnabled() bool {
	if o == nil || IsNil(o.Enabled) {
		var ret bool
		return ret
	}
	return *o.Enabled
}

// GetEnabledOk returns a tuple with the Enabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Validation) GetEnabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Enabled) {
		return nil, false
	}
	return o.Enabled, true
}

// HasEnabled returns a boolean if a field has been set.
func (o *Validation) HasEnabled() bool {
	if o != nil && !IsNil(o.Enabled) {
		return true
	}

	return false
}

// SetEnabled gets a reference to the given bool and assigns it to the Enabled field.
func (o *Validation) SetEnabled(v bool) {
	o.Enabled = &v
}

// GetRules returns the Rules field value if set, zero value otherwise.
func (o *Validation) GetRules() []ValidationRule {
	if o == nil || IsNil(o.Rules) {
		var ret []ValidationRule
		return ret
	}
	return o.Rules
}

// GetRulesOk returns a tuple with the Rules field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Validation) GetRulesOk() ([]ValidationRule, bool) {
	if o == nil || IsNil(o.Rules) {
		return nil, false
	}
	return o.Rules, true
}

// HasRules returns a boolean if a field has been set.
func (o *Validation) HasRules() bool {
	if o != nil && !IsNil(o.Rules) {
		return true
	}

	return false
}

// SetRules gets a reference to the given []ValidationRule and assigns it to the Rules field.
func (o *Validation) SetRules(v []ValidationRule) {
	o.Rules = v
}

// GetErrorMessage returns the ErrorMessage field value if set, zero value otherwise.
func (o *Validation) GetErrorMessage() Message {
	if o == nil || IsNil(o.ErrorMessage) {
		var ret Message
		return ret
	}
	return *o.ErrorMessage
}

// GetErrorMessageOk returns a tuple with the ErrorMessage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Validation) GetErrorMessageOk() (*Message, bool) {
	if o == nil || IsNil(o.ErrorMessage) {
		return nil, false
	}
	return o.ErrorMessage, true
}

// HasErrorMessage returns a boolean if a field has been set.
func (o *Validation) HasErrorMessage() bool {
	if o != nil && !IsNil(o.ErrorMessage) {
		return true
	}

	return false
}

// SetErrorMessage gets a reference to the given Message and assigns it to the ErrorMessage field.
func (o *Validation) SetErrorMessage(v Message) {
	o.ErrorMessage = &v
}

func (o Validation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Validation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Enabled) {
		toSerialize["enabled"] = o.Enabled
	}
	if !IsNil(o.Rules) {
		toSerialize["rules"] = o.Rules
	}
	if !IsNil(o.ErrorMessage) {
		toSerialize["error_message"] = o.ErrorMessage
	}
	return toSerialize, nil
}

type NullableValidation struct {
	value *Validation
	isSet bool
}

func (v NullableValidation) Get() *Validation {
	return v.value
}

func (v *NullableValidation) Set(val *Validation) {
	v.value = val
	v.isSet = true
}

func (v NullableValidation) IsSet() bool {
	return v.isSet
}

func (v *NullableValidation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableValidation(val *Validation) *NullableValidation {
	return &NullableValidation{value: val, isSet: true}
}

func (v NullableValidation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableValidation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


